let Ajax = {}

Ajax.get = (url, headers = {}) => {
  return doRequest('GET', url, null, headers);
};

Ajax.post = (url, payload, headers = {}) => {
  return doRequest('POST', url, payload, headers);
};

Ajax.request = (verb, url, payload, headers = {}) => {
  return doRequest(verb, url, payload, headers);
};

let doRequest = (verb, url, payload, headers) => {
  let req = new XMLHttpRequest();
  req.open(verb, url, true);

  if(typeof payload === 'object') {
    headers['Content-Type'] = 'application/json; charset=utf-8';
    payload = JSON.stringify(payload);
  }

  Object.keys(headers).forEach(k => {
    req.setRequestHeader(k, headers[k]);
  });

  return new Promise((resolve, reject) => {
    req.onreadystatechange = () => {
      if (req.readyState != 4) return;
      if(req.status > 299) {
        reject(req);
        return;
      }

      if(req.getResponseHeader('content-type').includes('json')) {
        resolve(JSON.parse(req.responseText));
        return;
      }

      resolve(req.responseText);
    };

    (payload) ? req.send(payload) : req.send();
  });
}

export default Ajax;
